package com.example.viniciusthiengo.exampleandroidtextjustify;

import android.graphics.Color;
import android.graphics.Typeface;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.SpannableStringBuilder;
import android.text.Spanned;
import android.text.method.LinkMovementMethod;
import android.text.style.ClickableSpan;
import android.text.style.ForegroundColorSpan;
import android.text.style.StyleSpan;
import android.text.style.URLSpan;
import android.text.util.Linkify;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.bluejamesbond.text.DocumentView;
import com.bluejamesbond.text.hyphen.HyphenPattern;
import com.bluejamesbond.text.hyphen.Hyphenator;
import com.bluejamesbond.text.style.JustifiedSpan;
import com.bluejamesbond.text.style.TextAlignment;

import java.lang.reflect.Type;


public class SpannedActivity extends ActionBarActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_spanned);

        LinearLayout llContainer = (LinearLayout) findViewById(R.id.llContainer);
        double sp = getResources().getDisplayMetrics().density * 18 + 0.5f;


        Spannable span = new SpannableStringBuilder("Nesse vídeo dou http://www.thiengo.com.br continuidade a série de vídeos sobre libs úteis no Android mostrando a lib Cropper que nos permite colocar a funcionalidade de corte de imagem em nossas APPs Android. Com a view CropImageView setamos a imagem (via XML ou Java API) e então os controles de corte já são apresentados ao usuário indicando a possibilidade de corte. Funcionalidade comum em redes sociais quando o usuário fornece a imagem de perfil ele tem a opção de corta-la. Dê atenção a funcionalidade de rotação de imagem, apesar da lib Cropper nos permitir rotacionar a imagem ela nã0 permanece com o novo direcionamento, nós temos então que acessar o bitmap gerado via método getCroppedImage() e com o auxílio de um novo Bitmap e um objeto Matrix colocar a correta rotação da imagem, no vídeo mostro como fazer isso. Se sua APP tem formlário em que o usuário pode entrar com uma imagem colocar essa funcionalidade de crop pode enriquecer ainda mais a APP. No mais não tenho muito o que falar, pois é bem tranquilo utilizar a lib.");
        span.setSpan(new StyleSpan(Typeface.BOLD_ITALIC), 10, 100, 0);
        span.setSpan(new ForegroundColorSpan(Color.RED), 140, 200, 0);
        span.setSpan(new URLSpan("http://www.google.com.br"), 0, 4, 0);
        span.setSpan(new ClickableSpan() {
            @Override
            public void onClick(View widget) {
                Toast.makeText(SpannedActivity.this, "Test", Toast.LENGTH_SHORT).show();
            }
        }, 6, 11, 0);


        Linkify.addLinks(span, Linkify.WEB_URLS);


        DocumentView dvText = new DocumentView(SpannedActivity.this, DocumentView.FORMATTED_TEXT);
        dvText.setText(span);
        dvText.getDocumentLayoutParams().setTextAlignment(TextAlignment.JUSTIFIED);
        dvText.setTextSize((int)sp);

        dvText.getDocumentLayoutParams().setHyphenator(new Hyphenator(HyphenPattern.PT));
        dvText.getDocumentLayoutParams().setHyphenated(true);


        llContainer.addView(dvText);
    }
}
